Loading...
Searching...
No Matches
pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT > Class Template Reference
Module keypoints

Detects BRISK interest points based on the original code and paper reference by. More...

`#include <pcl/keypoints/brisk_2d.h>`

Inheritance diagram for pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >:

## Public Types

using | Ptr = shared_ptr< BriskKeypoint2D< PointInT, PointOutT, IntensityT > >
using | ConstPtr = shared_ptr< const BriskKeypoint2D< PointInT, PointOutT, IntensityT > >
using | PointCloudIn = typename Keypoint< PointInT, PointOutT >::PointCloudIn
using | PointCloudOut = typename Keypoint< PointInT, PointOutT >::PointCloudOut
using | KdTree = typename Keypoint< PointInT, PointOutT >::KdTree
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
Public Types inherited from pcl::Keypoint< ImageType >
using | Ptr = shared_ptr< Keypoint< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Keypoint< PointInT, PointOutT > >
using | BaseClass = PCLBase< PointInT >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(pcl::index_t, double, pcl::Indices &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, pcl::index_t index, double, pcl::Indices &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| BriskKeypoint2D (int octaves=4, int threshold=60)
| Constructor.
| ~BriskKeypoint2D () override=default
| Destructor.
void | setThreshold (const int threshold)
| Sets the threshold for corner detection.
std::size_t | getThreshold ()
| Get the threshold for corner detection, as set by the user.
void | setOctaves (const int octaves)
| Set the number of octaves to use.
int | getOctaves ()
| Returns the number of octaves used.
void | setRemoveInvalid3DKeypoints (bool remove)
| Specify whether we should do a 2nd pass through the list of keypoints found, and remove the ones that do not have a valid 3D (x-y-z) position (i.e., are NaN or Inf).
bool | getRemoveInvalid3DKeypoints ()
| Specify whether the keypoints that do not have a valid 3D position are kept (false) or removed (true).
void | bilinearInterpolation (const PointCloudInConstPtr &cloud, float x, float y, PointOutT &pt)
Public Member Functions inherited from pcl::Keypoint< ImageType >
| Keypoint ()=default
void | harrisCorner (ImageType &output, ImageType &input, const float sigma_d, const float sigma_i, const float alpha, const float thresh)
void | hessianBlob (ImageType &output, ImageType &input, const float sigma, bool SCALE)
void | hessianBlob (ImageType &output, ImageType &input, const float start_scale, const float scaling_factor, const int num_scales)
void | imageElementMultiply (ImageType &output, ImageType &input1, ImageType &input2)
| Keypoint ()
| Empty constructor.
| ~Keypoint () override=default
| Empty destructor.
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for.
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used.
double | getSearchParameter ()
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection.
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors.
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()
int | searchForNeighbors (pcl::index_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

bool | initCompute () override
| Initializes everything and checks whether input data is fine.
void | detectKeypoints (PointCloudOut &output) override
| Detects the keypoints.
Protected Member Functions inherited from pcl::Keypoint< ImageType >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual void | detectKeypoints (PointCloudOut &output)=0
| Abstract key point detection method.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Additional Inherited Members

Protected Attributes inherited from pcl::Keypoint< ImageType >
std::string | name_
| The key point detection method's name.
SearchMethod | search_method_
| The search method template for indices.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_ {0.0}
| The actual search parameter (casted from either search_radius_ or k_).
double | search_radius_ {0.0}
| The nearest neighbors search radius for each point.
int | k_ {0}
| The number of K nearest neighbors to use for each point.
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT, typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>
class pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >

Detects BRISK interest points based on the original code and paper reference by.

  Stefan Leutenegger,Margarita Chli and Roland Siegwart, BRISK: Binary Robust Invariant Scalable Keypoints, in Proceedings of the IEEE International Conference on Computer Vision (ICCV2011).

Code example:

pcl::PointCloud<pcl::PointXYZRGBA> cloud;
pcl::BriskKeypoint2D<pcl::PointXYZRGBA> brisk;
brisk.setThreshold (60);
brisk.setOctaves (4);
brisk.setInputCloud (cloud);
PointCloud<pcl::PointWithScale> keypoints;
brisk.compute (keypoints);
pcl::BriskKeypoint2D
Detects BRISK interest points based on the original code and paper reference by.
Definition brisk_2d.h:74
pcl::BriskKeypoint2D::setThreshold
void setThreshold(const int threshold)
Sets the threshold for corner detection.
Definition brisk_2d.h:105
pcl::BriskKeypoint2D::setOctaves
void setOctaves(const int octaves)
Set the number of octaves to use.
Definition brisk_2d.h:121
pcl::Keypoint::compute
void compute(PointCloudOut &output)
Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using t...
Definition keypoint.hpp:137
pcl::PCLBase::setInputCloud
virtual void setInputCloud(const PointCloudConstPtr &cloud)
Provide a pointer to the input dataset.
Definition pcl_base.hpp:65
pcl::PointCloud
PointCloud represents the base class in PCL for storing collections of 3D points.
Definition point_cloud.h:173

Author
  Radu B. Rusu, Stefan Holzer

Definition at line 73 of file brisk_2d.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

using pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::ConstPtr = shared_ptr<const BriskKeypoint2D<PointInT, PointOutT, IntensityT> >

Definition at line 77 of file brisk_2d.h.

## KdTree

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

using pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::KdTree = typename Keypoint<PointInT, PointOutT>::KdTree

Definition at line 81 of file brisk_2d.h.

## PointCloudIn

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

using pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::PointCloudIn = typename Keypoint<PointInT, PointOutT>::PointCloudIn

Definition at line 79 of file brisk_2d.h.

## PointCloudInConstPtr

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

using pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::PointCloudInConstPtr = typename PointCloudIn::ConstPtr

Definition at line 82 of file brisk_2d.h.

## PointCloudOut

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

using pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::PointCloudOut = typename Keypoint<PointInT, PointOutT>::PointCloudOut

Definition at line 80 of file brisk_2d.h.

## Ptr

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

using pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::Ptr = shared_ptr<BriskKeypoint2D<PointInT, PointOutT, IntensityT> >

Definition at line 76 of file brisk_2d.h.

## Constructor & Destructor Documentation

## BriskKeypoint2D()

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::BriskKeypoint2D | ( | int | octaves = `4`,
|  | int | threshold = `60`
| ) |  |

inline

Constructor.

Definition at line 90 of file brisk_2d.h.

References pcl::Keypoint< ImageType >::k_, and pcl::Keypoint< ImageType >::name_.

## ~BriskKeypoint2D()

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::~BriskKeypoint2D | ( |  | ) |

override default

Destructor.

## Member Function Documentation

## bilinearInterpolation()

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::bilinearInterpolation | ( | const PointCloudInConstPtr & | cloud,
|  | float | x,
|  | float | y,
|  | PointOutT & | pt
| ) |  |

inline

Definition at line 155 of file brisk_2d.h.

References pcl::isFinite().

## detectKeypoints()

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints | ( | PointCloudOut & | output | ) |

override protected

Detects the keypoints.

Definition at line 69 of file brisk_2d.hpp.

References pcl::copyPointCloud(), pcl::isFinite(), and pcl::PointCloud< PointT >::points.

## getOctaves()

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

int pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::getOctaves | ( |  | ) |

inline

Returns the number of octaves used.

Definition at line 128 of file brisk_2d.h.

## getRemoveInvalid3DKeypoints()

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

bool pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::getRemoveInvalid3DKeypoints | ( |  | ) |

inline

Specify whether the keypoints that do not have a valid 3D position are kept (false) or removed (true).

Definition at line 148 of file brisk_2d.h.

## getThreshold()

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

std::size_t pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::getThreshold | ( |  | ) |

inline

Get the threshold for corner detection, as set by the user.

Definition at line 112 of file brisk_2d.h.

## initCompute()

template<typename PointInT , typename PointOutT , typename IntensityT >

bool pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::initCompute | ( |  | ) |

override protected virtual

Initializes everything and checks whether input data is fine.

Reimplemented from pcl::Keypoint< ImageType >.

Definition at line 50 of file brisk_2d.hpp.

## setOctaves()

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::setOctaves | ( | const int | octaves | ) |

inline

Set the number of octaves to use.

Parameters

  [in] | octaves | the number of octaves to use

Definition at line 121 of file brisk_2d.h.

## setRemoveInvalid3DKeypoints()

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::setRemoveInvalid3DKeypoints | ( | bool | remove | ) |

inline

Specify whether we should do a 2nd pass through the list of keypoints found, and remove the ones that do not have a valid 3D (x-y-z) position (i.e., are NaN or Inf).

Parameters

  [in] | remove | set to true whether we want the invalid 3D keypoints removed

Definition at line 139 of file brisk_2d.h.

## setThreshold()

template<typename PointInT , typename PointOutT = pcl::PointWithScale, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::setThreshold | ( | const int | threshold | ) |

inline

Sets the threshold for corner detection.

Parameters

  [in] | threshold | the threshold used for corner detection.

Definition at line 105 of file brisk_2d.h.

The documentation for this class was generated from the following files:

- pcl/keypoints/brisk_2d.h
- pcl/keypoints/impl/brisk_2d.hpp